function [activities,access_token] = getData()
%GETDATA Stahne data ze strava.com, pokud byla stažena v minulosti tak jen
%aktualizuje chybějící data o trase.
%   Vrací pole aktivit a aktualni acces token.

%% Načítání dat
fprintf("Načítám data.\n");
if exist('data.mat','file')
    load('data.mat','data','index_by_id');
else
    fprintf("Nebyl nalezen soubor 'data.mat', všechna data budou znovu stažena!\n");
    index_by_id=containers.Map();
end

%% Stažení seznamu aktivit
access_token=getAccessToken();
options = weboptions('Timeout',50,'ArrayFormat','json','HeaderFields',{'Authorization',['Bearer ', access_token]});
activities={};
%stahne 5*200 aktivit
fprintf("Stahuji seznam aktivit...\n");
for i=1:3
    try
    activities=[activities;webread('https://www.strava.com/api/v3/athlete/activities','access_token',access_token,'per_page',200,'page',i,options)]; %%stahne vsechny aktivity

    catch ME
        if exist('data','var')
            fprintf("chyba:\n%s\nNebyl stažen úplný seznam aktivit, použiju uložená data.\n",ME.message);
            activities = data;
        else
            fprintf("chyba:\n%s\nNebyl stažen úplný seznam aktivit... :[ \n",ME.message);
        end
        return
    end
end

%% Stažení dat o dráze jedné dané aktivity
count=length(activities);
%stahne data o draze
fprintf("Stahuji data aktivit...\n");
for i=1:count
    %pokud je aktivita ulozena v datech nacte track z dat
    if isKey(index_by_id,activities{i}.id) && isfield(data{index_by_id(activities{i}.id)},'track')
        activities{i}.track=data{index_by_id(activities{i}.id)}.track;
    elseif activities{i}.start_latlng
        try
            tmp=webread(['https://www.strava.com/api/v3/activities/',...
                num2str(activities{i}.id),'/streams/latlng,altitude,time,heartrate,moving,velocity_smooth'],options);
        catch ME
            fprintf("chyba: %s\n",ME.message);
            break 
        end
        for j=1:size(tmp,1)
            track.(tmp(j).type)=tmp(j).data;
        end
        activities{i}.track=track;
        

    end
end

%% Ukládání dat
fprintf("Ukládám data.\n");
data=activities;
index_by_id=containers.Map(data{1}.id,1,'UniformValues',true);

for i=1: length(data)
    index_by_id(data{i}.id)=i;
end

save('data.mat','data','index_by_id');
fprintf("Data uložena.\n");
